--------------------------------------------------------------------------------
--
-- Modulname:			bcd_to_seg.vhd
-- Projektname:		funktionsgenerator.ise
-- Ersteller:			Thomas Brunnengrber
--	Firma:				Privat
-- Erstellt:			26.03.2006
-- Zielsystem:			Spartan 3
-- Tool versions:		XILINX ISE 8.1
-- Revision:			1.0
-- Abhngigkeiten:	keine
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity bcd_to_7seg is
    port ( enable : in std_logic;
	 		  bcd : in std_logic_vector(3 downto 0);
           led : out std_logic_vector(0 to 6) );
end bcd_to_7seg;

architecture Behavioral of bcd_to_7seg is
	signal disp : std_logic_vector(0 to 6);
begin
 	recode : process (bcd)
	begin
		case bcd is
			when "0000" => disp <= "0000001";
			when "0001" =>	disp <= "1001111";
			when "0010" =>	disp <= "0010010";
			when "0011" =>	disp <= "0000110";
			when "0100" => disp <= "1001100";
			when "0101" => disp <= "0100100";
			when "0110" => disp <= "0100000";
			when "0111" => disp <= "0001111";
			when "1000" => disp <= "0000000";
			when "1001" => disp <= "0000100";
			when "1010" => disp <= "0001000";
			when "1011" => disp <= "1100000";
			when "1100" => disp <= "0110001";
			when "1101" => disp <= "1000010";
			when "1110" => disp <= "0110000";
			when "1111" => disp <= "0111000";
			when others => disp <= "1111110";
		end case;
	end process recode;

	display : process (enable, disp)
	begin
		if enable = '1' then
			led <= disp;
		else
			led <= "ZZZZZZZ";
		end if;
	end process display;

end Behavioral;
